/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.commons;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.struts2.ServletActionContext;
import org.blueoxygen.cimande.persistence.GenericPersistenceManager;
import org.blueoxygen.cimande.persistence.PersistenceManager;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

public class BlueOxygenSessionCredentials {

	@Autowired
//	private PersistenceManager persistenceManager;
	private GenericPersistenceManager genericPersistenceManager;

	public void setGenericPersistenceManager(
			GenericPersistenceManager genericPersistenceManager) {
		this.genericPersistenceManager = genericPersistenceManager;
	}

	public User getBackendUser() {
		String hashCode = (String) getSession().getAttribute("GA_USER");
		StringUtils stringUtils = new StringUtils();
		String memberId = stringUtils.decodeBase64(hashCode);
		User user = (User) genericPersistenceManager.getByUniqueField(User.class,
				memberId, "username");
		return user;
	}

	private HttpServletRequest getRequest() {
		return ServletActionContext.getRequest();
	}

	private HttpSession getSession() {
		return ServletActionContext.getRequest().getSession();
	}
}
