package org.blueoxygen.cimande.gx.tab;

import java.lang.reflect.InvocationTargetException;
import java.sql.Timestamp;

import org.apache.commons.beanutils.PropertyUtils;
import org.blueoxygen.cimande.commons.LogInformation;
import org.blueoxygen.cimande.gx.entity.GxTab;
import org.blueoxygen.cimande.gx.entity.GxTable;
import org.blueoxygen.cimande.gx.entity.GxWindow;

public class SaveTab extends TabForm {

	public String execute() {
		if (getTab().getName().equalsIgnoreCase("")) {
			addActionError("Name can not be empty");
		}
		if (getWindow().getId() == null
				|| "".equalsIgnoreCase(getWindow().getId())) {
			addActionError("Select the window first");
		} else {
			setWindow((GxWindow) manager.getById(GxWindow.class, getWindow()
					.getId()));
		}
		if (getTable().getId() == null
				|| "".equalsIgnoreCase(getTable().getId())) {
			addActionError("Table can not be empty");
		} else {
			setTable((GxTable) manager.getById(GxTable.class, getTable()
					.getId()));
		}

		if (hasActionErrors()) {
			return INPUT;
		}

		LogInformation log;
		if (getTab().getId() == null) {
			log = new LogInformation();
			log.setCreateBy(getCurrentUser().getId());
			log.setCreateDate(new Timestamp(System.currentTimeMillis()));
		} else if (getTab().getId() != null
				&& "".equalsIgnoreCase(getTab().getId())) {
			log = new LogInformation();
			log.setCreateBy(getCurrentUser().getId());
			log.setCreateDate(new Timestamp(System.currentTimeMillis()));
			getTab().setId(null);
		} else {
			GxTab temp = getTab();
			setTab((GxTab) manager.getById(GxTab.class, getTab().getId()));
			log = getTab().getLogInformation();
			try {
				PropertyUtils.copyProperties(getTab(), temp);
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				e.printStackTrace();
			}
		}
		log.setActiveFlag(1);
		log.setLastUpdateBy(getCurrentUser().getId());
		log.setLastUpdateDate(new Timestamp(System.currentTimeMillis()));

		getTab().setLogInformation(log);
		getTab().setTable(getTable());
		getTab().setWindow(getWindow());
		manager.save(getTab());
		setReport("Save Success");
		return SUCCESS;
	}

}
