/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.jobdescription.actions;

import org.blueoxygen.cimande.jobdescription.JobDesc;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class EditJobDesc extends JobDescForm {

	public String execute() {
		JobDesc job = service.getJobDescById(getId());

		if (job == null) {
			addActionError("Cannot find such jobiptor");
			return ERROR;

		} else {

			if (getName().equalsIgnoreCase("")) {
				addActionError("Name can't be empty");
			}
			if (getDescription().equalsIgnoreCase("")) {
				addActionError("Description can't be empty");
			}

			job.setName(getName());
			job.setDescription(getDescription());
			if (hasErrors()) {
				return INPUT;
			} else {
				service.save(job);
				return SUCCESS;
			}
		}

	}

}