/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.jobdescription.actions;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.jobdescription.JobDesc;
import org.blueoxygen.cimande.jobdescription.service.JobdescriptionServis;
import org.springframework.beans.factory.annotation.Autowired;

/*******************************
 * @author Praditya Eldorado
 * 		   aldo.donal@gmail.com
 *******************************/

public class ViewJobDesc extends CimandeAction {

	protected JobDesc jobDesc;
	private String id;
	protected @Autowired
	JobdescriptionServis service;

	public String execute() {
		jobDesc = service.getJobDescById(getId());

		model.put("jobdesc", jobDesc);

		if (jobDesc == null) {
			addActionError("Cannot find such Job Description");
			return ERROR;
		} else {
			return SUCCESS;
		}
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public JobDesc getJobDesc() {
		return jobDesc;
	}

	public void setJobDesc(JobDesc jobDesc) {
		this.jobDesc = jobDesc;
	}

}