/**
 * 
 */
package org.blueoxygen.cimande.persistence;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Projections;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author Dian Aditya
 * 
 */
@Repository
@Transactional(readOnly = true)
public class PersistenceCriteria<T> {
	private List<Criterion> criterions = new ArrayList<Criterion>();

	@Autowired
	private SessionFactory factory;
	private Class clazz = null;

	public PersistenceCriteria() {
		// clazz = (Class) ((ParameterizedType)
		// getClass().getGenericSuperclass())
		// .getActualTypeArguments()[0];
	}

	@Transactional(readOnly = true)
	public int getAllRowCount() {
		Criteria criteria = factory.getCurrentSession().createCriteria(clazz);

		for (Criterion criterion : criterions) {
			criteria.add(criterion);
		}

		criteria.setProjection(Projections.rowCount());

		return new Integer(criteria.uniqueResult() + "");
	}

	@Transactional(readOnly = true)
	public List<T> getList(int max, int first) {
		Criteria criteria = factory.getCurrentSession().createCriteria(clazz);

		for (Criterion criterion : criterions) {
			criteria.add(criterion);
		}

		criteria.setMaxResults(max).setFirstResult(first);

		return criteria.list();
	}

	public void add(Criterion criterion) {
		this.criterions.add(criterion);
	}

	public void setClass(Class<T> clazz) {
		this.clazz = clazz;
	}
}
