package org.blueoxygen.cimande.registration;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import net.tanesha.recaptcha.ReCaptcha;
import net.tanesha.recaptcha.ReCaptchaResponse;

import org.apache.struts2.ServletActionContext;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.blueoxygen.cimande.commons.LogInformation;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.UserRole;
import org.blueoxygen.cimande.security.Name;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.cimande.security.UserAccessor;
import org.blueoxygen.cimande.security.usermanager.UserSite;
import org.blueoxygen.cimande.site.Site;
import org.blueoxygen.cimande.social.SocialAccount;

public class RegisterUser extends RegistrationForm {
	@Inject
	private UserAccessor ua;

	@Inject
	private ReCaptcha reCaptcha;

	private String socialId = "";

	@SuppressWarnings("unchecked")
	public String execute() {
		if (getUsername() == null || "".equals(getUsername())) {
			addActionError("Username is required");
		}
		List<User> users = (ArrayList<User>) manager.getList("SELECT u FROM "
				+ User.class.getName() + " u WHERE u.username='"
				+ getUsername() + "'", null, null);
		if (!users.isEmpty()) {
			addActionError("User already exist!");
		}
		if (getEmail() == null || "".equals(getEmail())) {
			addActionError("Email is required");
		}
		List<User> emails = (ArrayList<User>) manager.getList("SELECT e FROM "
				+ User.class.getName() + " e WHERE e.email='" + getEmail()
				+ "'", null, null);
		if (!emails.isEmpty()) {
			addActionError("An Email has been using by another account, please check again.");
		}

		if (getPassword() == null || "".equals(getPassword())) {
			addActionError("Password is required");
		}
		if (!getPassword().equals(getCpassword())) {
			addActionError("Retype password and confirm password");
		}
		if (getFirstName() == null || "".equals(getFirstName())) {
			addActionError("First name is required");
		}
		// reCaptcha = new ReCaptchaImpl();
		// reCaptcha.setPrivateKey(get("captcha.private.key"));
		ReCaptchaResponse reCaptchaResponse = reCaptcha.checkAnswer(
				ServletActionContext.getRequest().getRemoteAddr(),
				recaptcha_challenge_field, recaptcha_response_field);
		if (!reCaptchaResponse.isValid()) {
			addActionError("Not a good Captcha");
		}

		if (hasActionErrors()) {
			return INPUT;
		}
		String ssite = get("application.site.default");
		String srole = get("application.role.default");
		Site site;
		Role role;
		System.out.println("ROLE = " + srole);
		if (srole != null && !"".equals(srole)) {
			role = (Role) manager.getByUniqueField(Role.class, srole, "name");
		} else {
			role = null;
		}

		User user = manager.getById(User.class, getUser().getId() == null ? ""
				: getUser().getId());

		if (user == null) {
			getUser().setId(null);

			getUser().setUsername(getUsername());// StringUtils.encodeBase64
			getUser().setPassword(su.encodeBase64(getPassword()));
			getUser().setName(new Name());
			getUser().getName().setFirst(getFirstName());
			getUser().getName().setLast(getLastName());
			getUser().setEmail(getEmail());
			getUser().setAddress(getAddress());
			getUser().setRole(role);
			getUser().setWorkspace_type("tree");

			if (Boolean.parseBoolean(get("application.user.activation.mail"))) {
				getUser().setLogInformation(new LogInformation(null, 0));
			} else {
				getUser().setLogInformation(new LogInformation(null, 1));
			}

			ua.signup(getUser());
		} else {
			user.setUsername(getUsername());// StringUtils.encodeBase64
			user.setPassword(su.encodeBase64(getPassword()));
			user.setName(new Name());
			user.getName().setFirst(getFirstName());
			user.getName().setLast(getLastName());
			user.setEmail(getEmail());
			user.setAddress(getAddress());
			user.setRole(role);
			user.setWorkspace_type("tree");

			if (Boolean.parseBoolean(get("application.user.activation.mail"))) {
				user.setLogInformation(new LogInformation(null, 0));
			} else {
				user.setLogInformation(new LogInformation(null, 1));
			}

			ua.signup(user);
			setUser(user);
		}

		SocialAccount socialAccount = manager.getById(SocialAccount.class,
				socialId);
		if (socialAccount != null) {
			socialAccount.setUser(getUser());

			manager.save(socialAccount);
		}

		UserRole ur = new UserRole();
		ur.setRole(role);
		ur.setUser(getUser());
		ur.setLogInformation(new LogInformation(getUser().getId(), 1));
		manager.save(ur);

		if (ssite != null && !"".equals(ssite)) {
			site = (Site) manager.getByUniqueField(Site.class, ssite, "name");
			UserSite us = new UserSite();
			us.setSite(site);
			us.setUser(getUser());
			us.setLogInformation(new LogInformation(getUser().getId(), 1));
			manager.save(us);
		}
		if (Boolean
				.parseBoolean(get("application.registration.activation.mail"))) {
			try {
				new SendActMail().send(getUser());
			} catch (ResourceNotFoundException e) {
				e.printStackTrace();
			} catch (ParseErrorException e) {
				e.printStackTrace();
			} catch (MethodInvocationException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		return SUCCESS;
	}

	public String getSocialId() {
		return socialId;
	}

	public void setSocialId(String socialId) {
		this.socialId = socialId;
	}

}
