/**
 * UrlHandler.java
 *
 * Created on 6 Sep 2010 16:03:07
 */
package org.blueoxygen.cimande.rest.commons;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * @author Dian Aditya
 *
 */
public class UrlHandler {
	public static final String HTTP_METHOD_PARAM = "_method";

	private UrlHandler() {
	}

	public static final String removeExtension(String string) {
		int idx = string.lastIndexOf('.');
		if (idx < 0) {
			return string;
		}

		string = string.substring(0, string.lastIndexOf('.'));

		return string;
	}

	public static final List<String> removeExtension(String[] strings) {
		List<String> temps = new ArrayList<String>();

		for (String temp : strings) {
			temps.add(removeExtension(temp));
		}

		return temps;
	}

	public static final List<String> removeExtension(List<String> strings) {
		return removeExtension(strings.toArray(new String[0]));
	}

	public static final Map<String, String> parameterListToMap(
			List<String> strings) {
		Map<String, String> temp = new HashMap<String, String>();

		if (strings.size() % 2 != 0) {
			strings.remove(strings.size() - 1);
		}

		for (int i = 0; i < strings.size(); i += 2) {
			temp.put(strings.get(i), strings.get(i + 1));
		}

		return temp;
	}

	public static final boolean isGet(HttpServletRequest request) {
		return "get".equalsIgnoreCase(request.getMethod());
	}

	public static final boolean isPost(HttpServletRequest request) {
		return "post".equalsIgnoreCase(request.getMethod());
	}

	public static final boolean isPut(HttpServletRequest request) {
		if ("put".equalsIgnoreCase(request.getMethod())) {
			return true;
		} else {
			return isPost(request)
					&& "put".equalsIgnoreCase(request
							.getParameter(HTTP_METHOD_PARAM));
		}
	}

	public static final boolean isDelete(HttpServletRequest request) {
		if ("delete".equalsIgnoreCase(request.getMethod())) {
			return true;
		} else {
			return "delete".equalsIgnoreCase(request
					.getParameter(HTTP_METHOD_PARAM));
		}
	}
}
