/**
 * ServiceInterceptor.java
 *
 * Created on 6 Sep 2010 14:52:06
 */
package org.blueoxygen.cimande.rest.interceptors;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;
import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.persistence.GenericPersistenceManager;
import org.blueoxygen.cimande.rest.manager.ContentHandlerManager;
import org.blueoxygen.cimande.security.LoginFilter;
import org.blueoxygen.cimande.site.Site;
import org.springframework.beans.factory.annotation.Autowired;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.inject.Inject;
import com.opensymphony.xwork2.interceptor.Interceptor;

/**
 * @author Dian Aditya
 * 
 */
public class ServiceInterceptor implements Interceptor {

	private ContentHandlerManager handlerManager;

	@Autowired
	private GenericPersistenceManager persistenceManager;

	@Inject
	public void setContentHandlerManager(ContentHandlerManager handlerManager) {
		this.handlerManager = handlerManager;
	}

	public void destroy() {
	}

	public void init() {
	}

	public String intercept(ActionInvocation invocation) throws Exception {
		HttpServletRequest request = ServletActionContext.getRequest();
		String servletPath = request.getServletPath();
		String key = request.getParameter("key");

		Site site = (Site) request.getSession().getAttribute("CIMANDE_SITE");
		
		if (handlerManager.getHandlerByExtension().containsKey(
				servletPath.substring(servletPath.lastIndexOf('/') + 1))) {
			if (site != null) {
				return invocation.invoke();
			} else {
				if (key == null) {
					return null;
				} else {
					String hql = "FROM "
							+ Site.class.getName()
							+ " WHERE secret_key = ? AND secret_key <> NULL AND secret_key <> ''";
					List<Site> sites = persistenceManager.find(hql,
							new Object[] { key }, new Class[] { String.class });

					if (sites.size() > 0) {
						site = sites.get(0);

						return invocation.invokeActionOnly();
					} else {
						return null;
					}
				}
			}
		}

		return invocation.invoke();
	}
}
