/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.role.actions;

import java.sql.Timestamp;

import org.blueoxygen.cimande.commons.LogInformation;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.security.SessionCredentials;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Validation
public class EditRole extends RoleForm {
	private Role rl = new Role();

	public void setSessionCredentials(SessionCredentials sessionCredentials) {
		this.sessionCredentials = sessionCredentials;
	}

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Name can't be empty."),
			@RequiredStringValidator(fieldName = "description", message = "Description can't be empty.") })
	public String execute() {
		role = service.getRoleById(getId());
		if (role == null) {
			addActionError("Such role couldn't be found. Edit process failed.");
			return ERROR;
		}

		else {
			if (getName().equalsIgnoreCase(""))
				addActionError("Name can't be empty.");
			if (getDescription().equalsIgnoreCase(""))
				addActionError("Description can't be empty.");
			if (hasErrors()) {
				return INPUT;
			} else {
				if (getParentId() != null
						&& !"".equalsIgnoreCase(getParentId())) {
					rl = service.getRoleById(getParentId());
				} else {
					rl = null;
				}
				role.setName(getName());
				role.setDescription(getDescription());
				role.setParentId(rl);
				role.getLogInformation().setActiveFlag(getActiveFlag());
				if (getWorkspace_type().equalsIgnoreCase("")) {
					role.setWorkspace_type(get("workspace.type.default.role"));
				} else {
					role.setWorkspace_type("tree");
				}
				if (!getParentId().equalsIgnoreCase("0")) {
					Role parent = (Role) manager.getById(Role.class,
							getParentId());
				}
				service.save(role);
				return SUCCESS;
			}
		}
	}
}