/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.role.actions;

import java.util.List;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.actions.servicewfrole.ServiceWfRole;
import org.springframework.beans.factory.annotation.Autowired;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class ListRole extends CimandeAction {

	private List<Role> roles;
	private String orderBy = "name";
	private String direction = "asc";
	private @Autowired
	ServiceWfRole service;

	public String execute() throws Exception {

		// roles = manager.findAllSortedDirected(Role.class, getOrderBy(),
		// getDirection());
		roles = service.getAllRoles(ob.name());
		model.put("rolelist", roles);

		return SUCCESS;
	}

	/**
	 * @return Returns the direction.
	 */
	public String getDirection() {
		return direction;
	}

	/**
	 * @param direction
	 *            The direction to set.
	 */
	public void setDirection(String direction) {
		this.direction = direction;
	}

	/**
	 * @return Returns the orderBy.
	 */
	public String getOrderBy() {
		return orderBy;
	}

	/**
	 * @param orderBy
	 *            The orderBy to set.
	 */
	public void setOrderBy(String orderBy) {
		this.orderBy = orderBy;
	}

	/**
	 * @return Returns the roles.
	 */
	public List<Role> getRoles() {
		return roles;
	}

	/**
	 * @param roles
	 *            The roles to set.
	 */
	public void setRoles(List<Role> workflows) {
		this.roles = workflows;
	}
}
