/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.role.actions;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.commons.CimandeModuleAction;
import org.blueoxygen.cimande.modulefunction.ModuleFunction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.actions.servicewfrole.ServiceWfRole;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.cimande.security.user.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class RoleForm extends CimandeAction {
	protected ModuleFunction moduleFunction;
	protected Role role;
	protected User user;
	private String id;
	private String name = "";
	private String description = "";
	private String siteId = "";
	private String parentId = "";
	private String workspace_type = "";
	private int activeFlag = -1; // dummy status, means unstated
	private String workType = "";
	protected @Autowired
	ServiceWfRole service;
	protected @Autowired
	UserService serviceuser;

	public String execute() {
		user = getCurrentUser();
		model.put("user", user);

		if (user.getWorkspace_type().equalsIgnoreCase("flat")) {
			workType = "flat";
		} else {
			workType = "";
		}
		return SUCCESS;
	}

	/**
	 * @return Returns the description.
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description
	 *            The description to set.
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id
	 *            The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return Returns the persistenceManager.
	 */
	// public PersistenceManager getPersistenceManager() {
	// return manager;
	// }
	// public GenericPersistenceManager getGenericPersistenceManager() {
	// return manager;
	// }

	/**
	 * @return Returns the activeFlag.
	 */
	public int getActiveFlag() {
		return activeFlag;
	}

	/**
	 * @param activeFlag
	 *            The activeFlag to set.
	 */
	public void setActiveFlag(int activeFlag) {
		this.activeFlag = activeFlag;
	}

	/**
	 * @return Returns the parentId.
	 */
	public String getParentId() {
		return parentId;
	}

	/**
	 * @param parentId
	 *            The parentId to set.
	 */
	public void setParentId(String parentId) {
		this.parentId = parentId;
	}

	/**
	 * @return Returns the moduleFunction.
	 */
	public ModuleFunction getModuleFunction() {
		return moduleFunction;
	}

	/**
	 * @param moduleFunction
	 *            The moduleFunction to set.
	 */
	public void setModuleFunction(ModuleFunction moduleFunction) {
		this.moduleFunction = moduleFunction;
	}

	/**
	 * @return Returns the role.
	 */
	public Role getRole() {
		return role;
	}

	/**
	 * @param role
	 *            The role to set.
	 */
	public void setRole(Role role) {
		this.role = role;
	}

	public String getWorkspace_type() {
		return workspace_type;
	}

	public void setWorkspace_type(String workspace_type) {
		this.workspace_type = workspace_type;
	}

	/**
	 * @return the user
	 */
	public User getUser() {
		return user;
	}

	/**
	 * @param user
	 *            the user to set
	 */
	public void setUser(User user) {
		this.user = user;
	}

	/**
	 * @return the workType
	 */
	public String getWorkType() {
		return workType;
	}

	/**
	 * @param workType
	 *            the workType to set
	 */
	public void setWorkType(String workType) {
		this.workType = workType;
	}

}
