/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.roleprivilage.actions;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.company.Company;
import org.blueoxygen.cimande.company.service.CompanyService;
import org.blueoxygen.cimande.role.RolePrivilage;
import org.blueoxygen.cimande.roleprivilage.service.RolePrivilageService;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * @author Miftachur Rohman
 *
 */
public class ViewRolePrivilage extends CimandeAction {

	protected @Autowired
	RolePrivilageService service;

	protected RolePrivilage rolePrivilage;
	private String id;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public RolePrivilage getRolePrivilage() {
		return rolePrivilage;
	}

	public String execute() {
		// rolePrivilage = (RolePrivilage) manager.getById(rolePrivilage.class, getId());
		rolePrivilage = service.getRolePrivilageById(getId());
		rootModel = rolePrivilage;

		if (rolePrivilage == null) {
			addActionError("Cannot find such descriptor");
			return ERROR;
		} else {
			return SUCCESS;
		}
	}
}