package org.blueoxygen.cimande.rolesite;

import java.util.ArrayList;
import java.util.List;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.RoleSite;
import org.blueoxygen.cimande.role.actions.servicewfrole.ServiceWfRole;
import org.blueoxygen.cimande.rolesite.service.ServiceRoleSite;
import org.blueoxygen.cimande.site.Site;
import org.blueoxygen.cimande.site.service.SiteService;
import org.springframework.beans.factory.annotation.Autowired;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class RoleSiteForm extends CimandeAction {

	private List<Role> roles = new ArrayList<Role>();
	private List<RoleSite> rolesites = new ArrayList<RoleSite>();
	private List<List<RoleSite>> listRoleSites = new ArrayList<List<RoleSite>>();
	private List<RoleSite> rolesitees = new ArrayList<RoleSite>();
	private RoleSite rolesite = new RoleSite();
	private String idRole = "";
	private Site site = new Site();
	private Role role = new Role();
	protected @Autowired
	ServiceWfRole roleService;
	protected @Autowired
	ServiceRoleSite service;
	protected @Autowired
	SiteService siteService;

	public String execute() {
		idRole = role.getId();
		if (role.getId() != null && !"".equalsIgnoreCase(role.getId())) {
			role = roleService.getRoleById(role.getId());
			while (role != null) {
				rolesites = service.getList(role.getId(), 1);
				listRoleSites.add(rolesites);
				role = role.getParentId();

			}
			role = roleService.getRoleById(idRole);
		}
		roles = roleService.getAllRoles(ob.name());
		model.put("role", role);
		model.put("rolesitelist", rolesites);
		model.put("rolesite", rolesite);
		model.put("rolelist", roles);
		model.put("listRoleSites", listRoleSites);

		return SUCCESS;
	}

	public List<RoleSite> getRolesitees() {
		return rolesitees;
	}

	public void setRolesitees(List<RoleSite> rolesitees) {
		this.rolesitees = rolesitees;
	}

	public List<Role> getRoles() {
		return roles;
	}

	public void setRoles(List<Role> roles) {
		this.roles = roles;
	}

	public Site getSite() {
		return site;
	}

	public void setSite(Site site) {
		this.site = site;
	}

	public Role getRole() {
		return role;
	}

	public void setRole(Role role) {
		this.role = role;
	}

	public List<RoleSite> getRolesites() {
		return rolesites;
	}

	public void setRolesites(List<RoleSite> rolesites) {
		this.rolesites = rolesites;
	}

	public RoleSite getRolesite() {
		return rolesite;
	}

	public void setRolesite(RoleSite rolesite) {
		this.rolesite = rolesite;
	}

}