/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.security.login;

import org.blueoxygen.cimande.security.LoginFilter;
import org.blueoxygen.cimande.security.login.interceptors.LoginInterceptor;

import com.opensymphony.xwork2.ActionContext;

public class Login extends LoginForm {

	public String execute() {
		if (ua.authenticate(getUsername(), getPassword())) {
			setUser(ua.getByUsername(getUsername()));
			if (getUser().getRole().getName().equalsIgnoreCase("default")) {
				addFieldError("username",
						"Sorry, your account not activated yet.");
				return INPUT;
			} else {
				// LOG.info("login successful: " + getUser().getUsername());
				// LOG.info("redirectUri  : " + getRedirectUri());

				ActionContext
						.getContext()
						.getSession()
						.put(LoginFilter.LOGIN_CIMANDE_USER,
								su.encodeBase64(getUser().getId()));
				ActionContext.getContext().getSession()
						.put(LoginInterceptor.CIMANDE_USER, getUser());

				/* Normal flow */
				return SUCCESS;
			}
		} else {
			addFieldError("username", "Invalid username or password.");
			return INPUT;
		}
	}

}