package org.blueoxygen.cimande.security.usermanager.actions;

import java.lang.reflect.InvocationTargetException;

import org.apache.commons.beanutils.PropertyUtils;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.util.StringUtils;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.StringLengthFieldValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

@Validation
public class AddUser extends UserForm {
	private User user = new User();
	String newPassword1 = "";

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "user.username", message = "Username can not empty"),
			@RequiredStringValidator(fieldName = "user.password", message = "Password can not empty"),
			@RequiredStringValidator(fieldName = "name.first", message = "First name can not empty"),
			@RequiredStringValidator(fieldName = "company.id", message = "Company can not empty"),
			@RequiredStringValidator(fieldName = "job.id", message = "Position can not empty") }, stringLengthFields = {
			@StringLengthFieldValidator(minLength = "3", fieldName = "user.username", message = "Username must have at least 3 characters"),
			@StringLengthFieldValidator(minLength = "3", fieldName = "user.password", message = "Password must have at least 3 characters") })
	public String execute() {
		newPassword1 = getNewPassword1();

		if (!newPassword1.equals(user.getPassword())) {
			addActionError("Incorrect Password");
		}
		String pass = "";
		StringUtils su = new StringUtils();
		if (hasErrors()) {
			return INPUT;

		} else {
			if (user.getId() == null) {
				pass = su.encodeBase64(user.getPassword());
			} else if (user.getId() != null
					&& "".equalsIgnoreCase(user.getId())) {
				user.setId(null);
				pass = su.encodeBase64(user.getPassword());
			} else {
				User temp = user;
				user = userService.getUserbyId(user.getId());
				pass = user.getPassword();
				Role role = user.getRole();

				try {
					PropertyUtils.copyProperties(user, temp);
					user.setRole(role);
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}
			}
			user.setUsername(user.getUsername());
			user.setPassword(pass);
			user.setAddress(getAddress());
			user.setName(getName());
			user.setCompany(getCompany());
			user.setJob(getJob());
			user.setDescription(user.getDescription());
			user.setEmail(user.getEmail());
			user.setWorkspace_type(user.getWorkspace_type());
			if (user.getWorkspace_type().equalsIgnoreCase("")) {
				user.setWorkspace_type("tree");
			} else {
				user.setWorkspace_type(user.getWorkspace_type());
			}
			service.save(user);
			return SUCCESS;
		}
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

}