/**
 * Copyright 2011 BlueOxygen Technology
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.blueoxygen.cimande.social.config;

import javax.swing.JOptionPane;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.social.facebook.connect.FacebookConnectionFactory;
import org.springframework.social.facebook.connect.FacebookServiceProvider;
import org.springframework.social.twitter.connect.TwitterConnectionFactory;
import org.springframework.social.twitter.connect.TwitterServiceProvider;

/**
 * @author Dian Aditya
 * 
 */
@Configuration
public class SocialConfig {

	@Value("${social.facebook.appId}")
	private String facebookClientId;

	@Value("${social.facebook.appSecret}")
	private String facebookClientSecret;

	@Value("${social.twitter.appId}")
	private String twitterClientId;

	@Value("${social.twitter.appSecret}")
	private String twitterClientSecret;

	@Bean
	public FacebookConnectionFactory facebookConnectionFactory() {
		return new FacebookConnectionFactory(facebookClientId,
				facebookClientSecret);
	}

	@Bean
	public TwitterConnectionFactory twitterConnectionFactory() {
		return new TwitterConnectionFactory(twitterClientId,
				twitterClientSecret);
	}
}
